/* $Id: creat.c,v 1.3 2004/10/16 08:47:55 pho Exp $ */

/* Stress the creat(2) system call */

#include <stdio.h>
#include <signal.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <err.h>

static int stop = 0;

void
handler(int i) {
	stop = 1;
}

#define NBFILES 50

int
main(int argc, char **argv) {
	int fd[NBFILES], i, j,  pid;
	char file[128];

	if (argc != 2) {
		fprintf(stderr, "Usage: %s <seconds>\n", argv[0]);
		exit(1);
	}

	i = 10;
	sscanf(argv[1], "%d", &i);
	pid = getpid();

	umask(0);
	signal(SIGALRM, handler);
	alarm(i);

	for (j = 0; j < 1000 && stop == 0; j++) {
		for (i = 0; i < NBFILES; i++) {
			sprintf(file,"p%05d.%05d", pid, i);
			if ((fd[i] = creat(file, 0660)) == -1) {
				err(1, "creat(%s)", file);
			}

		}

		for (i = 0; i < NBFILES; i++) {
			if (close(fd[i]) == -1) {
				err(2, "close(%d)", i);
			}

			sprintf(file,"p%05d.%05d", pid, i);
			if (unlink(file) == -1) {
				err(3, "unlink(%s)", file);
			}
		}
	}
	return 0;
}
