/* $Id: longjmp.c,v 1.1 2003/06/10 07:12:23 pho Exp $ */

#include <stdio.h>
#include <setjmp.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/wait.h>

jmp_buf env, redo;
pid_t pid;
int nb = 0;
int sec=2;

void
handler(int i) {
	if (pid != 0) {
		kill(pid, SIGHUP);
		kill(pid, SIGKILL);
	}
/*	printf("nb = %d\n", nb);*/
	exit(1);
}

void
again(int i) {
	nb++;
	longjmp(redo, 32);
}


void
child(void) {
	int i;

	signal(SIGALRM, handler);
	alarm(sec);

	for (;;) {
		if (setjmp(redo) == 32) {
			printf(".");
			fflush(stdout);
		}

		signal(SIGBUS,  again);
		signal(SIGSEGV, again);
		signal(SIGSYS,  again);
		signal(SIGILL,  again);
		signal(SIGTRAP, again);
		signal(SIGFPE,  again);
		signal(SIGURG,  again);

		for (i = 0; i < (sizeof(jmp_buf) / sizeof(int)); i++)
			env[0]._jb[i] = random();

		longjmp(env, 1);
	}
}

int
main(int argc, char **argv) {
	int status;

	if (argc != 2) {
		fprintf(stderr, "Usage: %s <secs>\n", argv[0]);
		return 1;
	}
	sscanf(argv[1], "%d", &sec);
	srandom(getpid());

	signal(SIGALRM, handler);
	alarm(sec);

	while (1) {
		pid = fork();
		if (pid == -1) {
			perror("fork");
			exit(2);
		}

		if (pid == 0) {
			child();
			printf("%s:%d\n", __FILE__, __LINE__);
		} else {
			wait(&status);
			/*
			if (WIFSIGNALED(status))
				printf("status: %d\n", WTERMSIG(status));*/
		}
	}
	return 0;
}
