/* $Id: memory.c,v 1.2 2004/06/17 09:09:39 pho Exp $ */
#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>

void
handler(int i) {
	exit(0);
}

extern char *optarg;
extern int optopt;

int
main(int argc, char **argv) {
	int ch, i, page, size;
	char *c;



	size = 256;	/* 1 Mb */
	sleep(2);	/* Wait for siblings to start */
	while ((ch = getopt(argc, argv, "s:")) != -1)
		switch (ch) {
			case 's':
				size = atoi(optarg);
				break;
			default:
				fprintf(stderr,
				"Usage: %s {-s <pages>} <seconds>\n", argv[0]);
				exit(1);
		}
	
	argc -= optind;
	argv += optind;
	if (argc > 0)
		i = atoi(*argv);
	else
		i = 60;


	page = getpagesize();
	size = size * page;
	signal(SIGALRM, handler);
	alarm(i);

	c = (char *)malloc(size);
	if (c == NULL) {
		perror("malloc");
		return(1);
	}

	while (1) {
		i = 0;
		while (i < size) {
			c[i] = i;
			i += page;
		}
	}

	return(0);
}
