/* $Id: mknod.c,v 1.5 2004/09/09 10:43:19 pho Exp $ */
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <signal.h>

#define PATH "./testdev"

void
handler(int i) {
	exit(0);
}


int
main(int argc, char **argv) {
	dev_t major, minor;
	mode_t mode;
	struct stat buf;
	char help[80], path[80];
	int i = 0;

	srandom(getpid());
	signal(SIGALRM, handler);
	alarm(60);

	for (;;) {
		sprintf(path, "%s.%d,%d", PATH, getpid(),i++);
		major = random();
		minor = random();
		mode = random();
		if ((mode & S_IFMT) == S_IFMT) continue;
		if (mknod(path, mode, makedev(major, minor)) == -1) {
			if (errno == EINVAL) continue;
			if (errno == ENOENT) continue;
			if (errno ==  EBADF) continue;
			sprintf(help, "mknod(%s, %d, 0x%x)", path,
				major, minor);
			perror(help);
			continue;
		}
		if (lstat(path, &buf) == -1) {
			sprintf(help, "mknod(%d, 0x%x)", major, minor);
			perror(help);
			continue;
		}
		if (unlink(path) == -1) {
			sprintf(help, "mknod(%d, 0x%x)", major, minor);
			perror(help);
			continue;
		}
	}
	return 0;
}
