#include <pthread.h>
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <err.h>

#define KTHREADS 10
#define NTHREADS 21

extern void udp(void);
int done = 0;

void
handler(int i) {
	done = 1;
}

void
memory(void) {
	char *c;
	int i;

	c = (char *)malloc(1024);
	for (i = 0; i < 1024; i++)
		c[i] = i % 256;
	free(c);
}

void
create(void) {
	int i;
	int fd;
	char file[80];

	for (i = 0; i < 1; i++) {
		sprintf(file, "file.%d.%lx", getpid(), (unsigned long)pthread_self());
		if ((fd = open(file, O_CREAT | O_RDWR, 0666)) == -1)
				err(1, "open(%s)", file);
		close(fd);
		unlink(file);
	}
}

void *
thr_routine(void *arg)
{
	int n;
	n = random() % 10000;
	usleep(n);   /*  0 - 0.01 sec */
	n = random() % 3;
	switch (n) {
		case 0:
			memory();
			break;
		case 1:
			create();
			break;
		case 2:
			udp();
			break;
		default:
			break;
	}
	return (0);
}

int main(int argc, char **argv)
{
	pthread_t threads[NTHREADS];
	int i;
	int r;
	
	i = 0;
	srandom(getpid());
	signal(SIGALRM, handler);
	alarm(60);

	if ((r = pthread_setconcurrency(KTHREADS)) != 0) {
		fprintf(stderr, "pthread_setconcurrency(%d): %s\n", KTHREADS,
			strerror(r));
		exit(1);
	}

	while (done != 1) {
		for (i = 0; i < NTHREADS; i++)
			if ((r = pthread_create(&threads[i], NULL, thr_routine, 0)) != 0)
				err(1, "pthread_create(): %s\n", strerror(r));

		for (i = 0; i < NTHREADS; i++)
			if (pthread_join(threads[i], NULL) != 0)
				err(1, "pthread_join(%d)", i);
	}

	return (0);
}
