/* $Id: syscall.c,v 1.1 2003/06/12 07:36:46 pho Exp $ */
#include <sys/syscall.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/wait.h>

pid_t pid;

void
handler(int i) {
	kill(pid, SIGHUP);
	kill(pid, SIGKILL);
	return;
}

int main(int argc, char **argv) {
	long i, arg1, arg2, arg3, arg4, arg5;
	int sec=2, smin, smax, status;

	if (argc != 4) {
		fprintf(stderr, "Usage: %s <min> <max> <seconds>\n", argv[0]);
		return 1;
	}

	sscanf(argv[1], "%d", &smin);
	sscanf(argv[2], "%d", &smax);
	sscanf(argv[3], "%d", &sec);

	srandom(getpid());

	for (i = smin; i <= smax; i++) {
		if (i == 0) continue;
		pid = fork();
		if (pid == -1) {
			perror("fork");
			exit(1);
		}

		if (pid == 0) {
			signal(SIGBUS, SIG_IGN);
			signal(SIGSEGV, SIG_IGN);
			signal(SIGSYS, SIG_IGN);
			printf("Testing syscall #%d\n", i);
			while(1) {
				arg1 = random();
				arg2 = random();
				arg3 = random();
				arg4 = random();
				arg5 = random();
/*				printf("syscall(%d, %d, %d, %d, %d, %d)\n",
					i, arg1, arg2, arg3, arg4, arg5);*/
				syscall(i, arg1, arg2, arg3, arg4, arg5);
			}
		} else {
			signal(SIGALRM, handler);
			alarm(sec);
			wait(&status);
		}
	}
	return 0;
}
