#!/bin/sh

# $Id$

# Annotate ddb witness output with procedure name

[ $# -ne 1 -o ! -f $1 ] && echo "Usage: $0 <log>" && exit 1

cat $1 | sed -e 's/
//g' -e 's///' -e 's/--More--//' | while read l; do
   if echo "$l" | grep "last acquired @" > /dev/null; then
      file=`echo $l | sed 's/.* @ //;s/:.*//'`
      line=`echo $l | sed 's/.*://'`
      [ $line -eq 0 ] && continue
      [ -r $file ] || file=/usr/src/sys/$file
###      echo "file = $file"
      proc=`awk -v target=$line '
/^[a-zA-Z_].*\(/ {
	sub("\\\(.*", "");
	proc=$0;
}
{
	line++;
	if (line - target == 0) {
		print proc;
		exit;
	}
}' < $file`
      printf "%-80s # %s\n" "$l" "$proc"
   else
      echo "$l"
   fi
done
